'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _diff = require('../diff');

var _diff2 = _interopRequireDefault(_diff);

var _createDOMNode = require('./createDOMNode');

var _createDOMNode2 = _interopRequireDefault(_createDOMNode);

var _patchDOM = require('./patchDOM');

var _patchDOM2 = _interopRequireDefault(_patchDOM);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function getDefaultKeyFromIndex(index) {
  return '.' + index;
}

function shouldUpdate(prevElement, nextElement, prevElementIndex, nextElementIndex) {
  var prevEmpty = prevElement === null || prevElement === false;
  var nextEmpty = nextElement === null || nextElement === false;
  if (prevEmpty || nextEmpty) {
    return prevEmpty === nextEmpty;
  }

  var prevType = typeof prevElement === 'undefined' ? 'undefined' : _typeof(prevElement);
  var nextType = typeof nextElement === 'undefined' ? 'undefined' : _typeof(nextElement);
  if (prevType === 'string' || prevType === 'number') {
    return nextType === 'string' || nextType === 'number';
  }
  return nextType === 'object' && prevElement.type === nextElement.type && (prevElement.key || getDefaultKeyFromIndex(prevElementIndex)) === (nextElement.key || getDefaultKeyFromIndex(nextElementIndex));
}

function renderDOM(vdom_, root) {
  var vdom = vdom_;
  if (!Array.isArray(vdom_)) {
    vdom = [vdom_];
  }
  vdom.forEach(function (n) {
    var c = (0, _createDOMNode2["default"])(n);
    root.appendChild(c);
  });
  var currentVDom = vdom;
  return {
    update: function update(nextVDom_) {
      var nextVDom = nextVDom_;
      if (!Array.isArray(nextVDom)) {
        nextVDom = [nextVDom];
      }
      var queue = (0, _diff2["default"])(currentVDom, nextVDom, { shouldUpdate: shouldUpdate });
      currentVDom = nextVDom;
      (0, _patchDOM2["default"])(queue, root);
      return queue;
    }
  };
}

exports["default"] = renderDOM;
module.exports = exports['default'];